# Function to calculate the sum of an orbitrary size integer array (regular)

	.intel_syntax noprefix
	.globl	FastSum
FastSum:
	push	rbp
	mov	rbp, rsp
	sub	rsp, 20
	mov	QWORD PTR [rbp-8], rdi
	mov	DWORD PTR [rbp-12], esi
	mov	DWORD PTR [rbp-16], 0
	mov	DWORD PTR [rbp-20], 0
	jmp	.L2
.L3:
	mov	rbx, QWORD PTR [rbp-8]
	mov	eax, DWORD PTR [rbp-20]
	cdqe
	mov	ecx, DWORD PTR [rbp-16]
	add	ecx, DWORD PTR [rbx+rax*4]
	mov	DWORD PTR [rbp-16], ecx
	mov	edx, DWORD PTR [rbp-20]
	add	edx, 1
	mov	DWORD PTR [rbp-20], edx
.L2:
	mov	ecx, DWORD PTR [rbp-20]
	cmp	ecx, DWORD PTR [rbp-12]
	jl	.L3
	mov	eax, DWORD PTR [rbp-16]
	mov	rsp, rbp
	pop	rbp
	ret

### C style ###
# int FastSum(int *A, int N){
#    int i, s;
#    s=0;
#    for(i=0;i<N;i++)
#      s=s+A[i];
#    return s;
#    }

